#include <bits/stdc++.h>

using namespace std;

typedef long long int LL;

const int N = 507;

int Turns, n, m;
int type[N][N];
int lastChange[N][N];

int anim;
int cnt[N][N];
char ans[N][N];

bool dead[N];
int lastMeal[N];
int who[N], x[N], y[N];

void killsheep(int dx, int dy, int turn){
	type[dx][dy] = 2;
	for(int i = 1; i <= anim; ++i)
		if(x[i] == dx && y[i] == dy && !dead[i] && who[i] == 0){
			dead[i] = true;
			break;
		}
	
	for(int i = 1; i <= anim; ++i)
		if(x[i] == dx && y[i] == dy && !dead[i] && who[i] == 1){
			lastMeal[i] = turn;
			break;
		}
}

int main(){
	scanf("%d %d %d", &Turns, &n, &m);
	for(int i = 1; i <= n; ++i){
		char input[N];
		scanf("%s", input + 1);
		
		for(int j = 1; j <= m; ++j){
			if(input[j] == '.')
				continue;
			
			++anim;
			if(input[j] == 'W')
				who[anim] = 1;
			x[anim] = i, y[anim] = j;
		}
	}
	
	for(int turn = 1; turn <= Turns; ++turn){
		for(int i = 1; i <= n; ++i)
			for(int j = 1; j <= m; ++j)
				cnt[i][j] = 0;
		
		for(int i = 1; i <= anim; ++i){
			if(dead[i])	continue;
			if(who[i] == 0){
				++x[i];
				if(x[i] > n)
					x[i] = 1;
			}
			else{
				++y[i];
				if(y[i] > m)
					y[i] = 1;
			}
			
			cnt[x[i]][y[i]] ++;
		}
		
		for(int i = 1; i <= n; ++i)
			for(int j = 1; j <= m; ++j){
				assert(cnt[i][j] <= 2);
				if(cnt[i][j] == 2)
					killsheep(i, j, turn);
			}
		
		for(int i = 1; i <= anim; ++i)
			if(!dead[i] && who[i] == 0){
				if(type[x[i]][y[i]] == 1){
					lastMeal[i] = turn;
					type[x[i]][y[i]] = 0;
					lastChange[x[i]][y[i]] = turn;
				}
			}
		
		for(int i = 1; i <= anim; ++i){
			if(dead[i])	continue;
			if(who[i] == 0 && turn - lastMeal[i] >= 5){
				dead[i] = true;
				type[x[i]][y[i]] = 2;
			}
			
			if(who[i] == 1 && turn - lastMeal[i] >= 10){
				dead[i] = true;
				type[x[i]][y[i]] = 2;
			}
		}

		for(int i = 1; i <= n; ++i)
			for(int j = 1; j <= m; ++j)
				if(type[i][j] == 0 && lastChange[i][j] <= turn - 3){
					type[i][j] = 1;
					lastChange[i][j] = turn;
				}
	}
	
	for(int i = 1; i <= n; ++i)
		for(int j = 1; j <= m; ++j)
			if(type[i][j] == 0)
				ans[i][j] = '.';
			else if(type[i][j] == 1)
				ans[i][j] = '#';
			else
				ans[i][j] = '*';
	
	for(int i = 1; i <= anim; ++i)
		if(!dead[i])
			ans[x[i]][y[i]] = who[i] == 0 ? 'S' : 'W';
	
	for(int i = 1; i <= n; ++i){
		for(int j = 1; j <= m; ++j)
			printf("%c", ans[i][j]);
		puts("");
	}

	return 0;
}
